#pragma once

#include <eopcc/cloud.hpp>
#include <fstream>

namespace eopcc {


class PointCloudReader {
protected:
  std::ifstream ifs_;
public:
  virtual ~PointCloudReader() {};
  virtual PointCloud ReadSubCloud(int sub_cloud_size) = 0;
  virtual size_t NumRemainingPoints() = 0;
  virtual PointCloud GetSeedCloud() = 0;
};

class PointCloudWriter {
public:
  virtual void WriteSubCloud(const PointCloud& sub_cloud) = 0;
  virtual ~PointCloudWriter() {};
};

} // end namespace eopcc
